SystemOrganization addCategory: #'Magritte-JQueryWidgetBox-Tests'!
SystemOrganization addCategory: #'Magritte-JQueryWidgetBox'!

!MADescription methodsFor: '*magritte-jquerywidgetbox' stamp: 'jmck 3/29/2011 21:22'!
cascadeId
	^self propertyAt: #cascadeId ifAbsent: nil! !

!MADescription methodsFor: '*magritte-jquerywidgetbox' stamp: 'jmck 3/29/2011 21:21'!
cascadeId: anId
	self propertyAt: #cascadeId put: anId! !

!MADescription methodsFor: '*magritte-jquerywidgetbox' stamp: 'jmck 3/29/2011 21:23'!
cascadeIds
	^self propertyAt: #cascadeIds ifAbsent: #()! !

!MADescription methodsFor: '*magritte-jquerywidgetbox' stamp: 'jmck 7/1/2011 21:32'!
cascadeIds: anArray
	self propertyAt: #cascadeIds put: (self cascadeIds copyWithAll: anArray)! !

!MADescription methodsFor: '*magritte-jquerywidgetbox' stamp: 'jmck 1/31/2011 20:48'!
replaceId
	^self propertyAt: #replaceId ifAbsent: [ nil ]! !

!MADescription methodsFor: '*magritte-jquerywidgetbox' stamp: 'jmck 1/31/2011 20:48'!
replaceId: aSymbol
	self propertyAt: #replaceId put: aSymbol! !

!MADescription methodsFor: '*magritte-jquerywidgetbox' stamp: 'jmck 1/31/2011 20:49'!
replaceIds
	^self propertyAt: #replaceIds ifAbsent: [ #() ]! !

!MADescription methodsFor: '*magritte-jquerywidgetbox' stamp: 'jmck 7/1/2011 21:45'!
replaceIds: anArray
	self propertyAt: #replaceIds put: (self replaceIds copyWithAll: anArray)! !

WAComponent subclass: #MJFunctionalTest
	instanceVariableNames: 'model component'
	classVariableNames: 'SearchObjects'
	poolDictionaries: ''
	category: 'Magritte-JQueryWidgetBox-Tests'!

!MJFunctionalTest class methodsFor: 'as yet unclassified' stamp: 'jmck 3/8/2011 20:05'!
buildSearchObjects
	^OrderedCollection new
		add: (MJSearchObject new testValue: 'abcdef'; lookupValue: 'lookup1'; replace1: '1'; replace2: '2'; yourself);
		add: (MJSearchObject new testValue: 'abcfed'; lookupValue: 'lookup2'; replace1: '3'; replace2: '4'; yourself);
		add: (MJSearchObject new testValue: 'abdef'; lookupValue: 'lookup3'; replace1: '5'; replace2: '6'; yourself);
		add: (MJSearchObject new testValue: 'abddef'; lookupValue: 'lookup4'; replace1: '7'; replace2: '8'; yourself);
		add: (MJSearchObject new testValue: 'abefg'; lookupValue: 'lookup5'; replace1: '9'; replace2: '10'; yourself);
		add: (MJSearchObject new testValue: 'abfdef'; lookupValue: 'lookup6'; replace1: '11'; replace2: '12'; yourself);
		yourself
		! !

!MJFunctionalTest class methodsFor: 'as yet unclassified' stamp: 'jmck 3/8/2011 20:57'!
initialize
	"self initialize"
	| app |
	app := WAAdmin register: self asApplicationAt: 'jquery-widgets/magritte'.
	app addLibrary: JQDeploymentLibrary;
		addLibrary: JQUiDeploymentLibrary;
		addLibrary: JQBaseTheme;
		addLibrary: JQWidgetBoxDeploymentLibrary;
		yourself.
		
	SearchObjects := self buildSearchObjects! !

!MJFunctionalTest class methodsFor: 'as yet unclassified' stamp: 'jmck 7/2/2011 12:40'!
reset	
	SearchObjects := self buildSearchObjects! !

!MJFunctionalTest methodsFor: 'as yet unclassified' stamp: 'jmck 3/8/2011 21:01'!
buildComponent
	^model asComponent! !

!MJFunctionalTest methodsFor: 'as yet unclassified' stamp: 'JohnMcKeon 10/4/2010 21:33'!
children
	^Array with: self component! !

!MJFunctionalTest methodsFor: 'as yet unclassified' stamp: 'JohnMcKeon 10/4/2010 21:33'!
component
	^component ifNil: [ component := self buildComponent ]! !

!MJFunctionalTest methodsFor: 'as yet unclassified' stamp: 'jmck 1/29/2011 12:52'!
initialize
	super initialize.
	model := MJMockObject new! !

!MJFunctionalTest methodsFor: 'as yet unclassified' stamp: 'jmck 7/2/2011 16:02'!
renderContentOn: html
	html heading level: 3; with: 'Magritte JQuery Functional Test'.
	html horizontalRule.
	html form: [
		html render: self component ].
	html horizontalRule.
	model date isNil
		ifFalse: [ html paragraph: 'The Date is: ', model date asString ].
	html break.
	model time isNil
		ifFalse: [ html paragraph: 'The Time is: ', model time asString ].
	model searchobject isNil
		ifFalse: [ html paragraph: 'Selected object: ', model searchobject asString ]! !

MATextInputComponent subclass: #MJDatepickerComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-JQueryWidgetBox'!

!MJDatepickerComponent commentStamp: 'jmck 1/28/2011 18:58' prior: 0!
A MJDatepickerComponent is Magritte component for looking up a date on a MADateDescription using the jQuery datepicker.

Instance Variables
!

!MJDatepickerComponent methodsFor: 'rendering' stamp: 'jmck 3/10/2011 21:25'!
renderInputOn: html
	html textInput
		attributeAt: 'autocomplete' put: 'off';
		id: self labelId;
		on: #string of: self;
		script: (html jQuery new datepicker
			onSelect: (html jQuery ajax serializeThis))! !

MATextInputComponent subclass: #MJTextInputComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-JQueryWidgetBox'!

!MJTextInputComponent class methodsFor: 'testing' stamp: 'jmck 3/10/2011 20:58'!
isAbstract
	^ false! !

!MJTextInputComponent methodsFor: 'testing' stamp: 'jmck 3/10/2011 20:58'!
hasLabelId
	^ self isReadonly not! !

!MJTextInputComponent methodsFor: 'rendering' stamp: 'jmck 3/10/2011 21:26'!
renderInputOn: html
	html textInput
		id: self labelId;
		attributeAt: 'autocomplete' put: 'off';
		on: #string of: self;
		onChange: (html jQuery ajax serializeThis)! !

MATextInputComponent subclass: #MJTimepickrComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-JQueryWidgetBox'!

!MJTimepickrComponent commentStamp: 'jmck 1/28/2011 19:02' prior: 0!
A MJTimepickrComponent is Magritte component for entering a time on a field described by a MATimeDescription using the jQuery timepickr. JQueryWidgetBox-Timepickr is required to use this component.

Instance Variables
!

!MJTimepickrComponent methodsFor: 'rendering' stamp: 'jmck 3/10/2011 21:26'!
renderInputOn: html
	html textInput
		id: self labelId;
		attributeAt: 'autocomplete' put: 'off';
		on: #string of: self;
		script: (html jQuery new timepickr
			trigger: 'focus';
			select: (html jQuery ajax serializeThis))! !

!MJTimepickrComponent methodsFor: 'rendering' stamp: 'jmck 2/8/2011 19:23'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot javascript url: JQWidgetBoxDeploymentLibrary / #timepickrJs.
	anHtmlRoot stylesheet url: JQWidgetBoxDeploymentLibrary / #timepickrCss.! !

!MAContainerComponent methodsFor: '*magritte-jquerywidgetbox' stamp: 'jmck 3/6/2011 01:02'!
scriptForm
	self scriptForm: #(save cancel)
	! !

!MAContainerComponent methodsFor: '*magritte-jquerywidgetbox' stamp: 'jmck 3/6/2011 01:01'!
scriptForm: aCollection
	self addDecoration: (MJFormDecoration buttons: aCollection)
	! !

!MAContainerComponent methodsFor: '*magritte-jquerywidgetbox' stamp: 'jmck 3/6/2011 01:16'!
scriptForm: aCollection withScript: aBlock
	self addDecoration: (MJFormDecoration new
		addButtons: aCollection;
		scriptBlock: aBlock;
		yourself)
	! !

Object subclass: #MJCascadedObject
	instanceVariableNames: 'testValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-JQueryWidgetBox-Tests'!

!MJCascadedObject methodsFor: 'accessing' stamp: 'jmck 7/2/2011 12:47'!
printOn: aStream
	aStream nextPutAll: 'cascade';
		nextPutAll: testValue greaseString! !

!MJCascadedObject methodsFor: 'accessing' stamp: 'jmck 6/28/2011 19:26'!
testValue
	"Answer the value of testValue"

	^ testValue! !

!MJCascadedObject methodsFor: 'accessing' stamp: 'jmck 6/28/2011 19:26'!
testValue: anObject
	"Set the value of testValue"

	testValue := anObject! !

Object subclass: #MJMockObject
	instanceVariableNames: 'date time searchobject replace1 replace2 cascaded1 cascaded2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-JQueryWidgetBox-Tests'!

!MJMockObject commentStamp: 'jmck 7/2/2011 12:12' prior: 0!
A MJMockObject is the object being edited in a magritte form. The searchobject variable will be "looked up" and various values from the lookeded-up object will populate the edited object. The replace values are like defaults retrieved from the looked-up object. The cascaded variables will get their own selection components from which the value for that field can be selected (the selection depends on the object selected)
!

!MJMockObject class methodsFor: 'accessing' stamp: 'jmck 7/2/2011 13:07'!
descriptionCascaded1
	^MAToOneRelationDescription new
		accessor: #cascaded1;
		label: 'Cascaded 1';
		cascadeId: #cascade1;
		componentClass: MJCascadeSelectComponent;
		priority: 50;
		yourself! !

!MJMockObject class methodsFor: 'accessing' stamp: 'jmck 7/2/2011 13:12'!
descriptionCascaded2
	^MAToOneRelationDescription new
		accessor: #cascaded2;
		label: 'Cascaded 2';
		cascadeId: #cascade2;
		componentClass: MJCascadeSelectComponent;
		priority: 60;
		yourself! !

!MJMockObject class methodsFor: 'accessing' stamp: 'jmck 1/20/2011 18:44'!
descriptionDate
	^MADateDescription new
		accessor: #date;
		label: 'Date';
		componentClass: MJDatepickerComponent;
		priority: 10;
		yourself! !

!MJMockObject class methodsFor: 'accessing' stamp: 'jmck 7/2/2011 16:19'!
descriptionObject
	^MAToOneRelationDescription new
		accessor: #searchobject;
		label: 'Object';
		classes: (Array with: MJSearchObject);
		componentClass: MJAutocompleteComponent;
		searchFields: #(#testValue);
		listFields: #(#testValue);
		updateId: #lookup;
		replaceIds: #(#replace1 #replace2);
		cascadeIds: #(#cascade1 #cascade2);
		priority: 1;
		yourself! !

!MJMockObject class methodsFor: 'accessing' stamp: 'jmck 3/8/2011 20:03'!
descriptionReplace1
	^MAStringDescription new
		accessor: #replace1;
		label: 'Replace1';
		replaceId: #replace1;
		priority: 2;
		yourself! !

!MJMockObject class methodsFor: 'accessing' stamp: 'jmck 3/8/2011 20:29'!
descriptionReplace2
	^MAStringDescription new
		accessor: #replace2;
		label: 'Replace2';
		replaceId: #replace2;
		priority: 2;
		yourself! !

!MJMockObject class methodsFor: 'accessing' stamp: 'jmck 1/20/2011 18:45'!
descriptionTime
	^MATimeDescription new
		accessor: #time;
		label: 'Time';
		componentClass: MJTimepickrComponent;
		priority: 20;
		yourself! !

!MJMockObject methodsFor: 'accessing' stamp: 'jmck 7/2/2011 12:05'!
cascaded1
	"Answer the value of cascaded1"

	^ cascaded1! !

!MJMockObject methodsFor: 'accessing' stamp: 'jmck 7/2/2011 12:05'!
cascaded1: anObject
	"Set the value of cascaded1"

	cascaded1 := anObject! !

!MJMockObject methodsFor: 'accessing' stamp: 'jmck 7/2/2011 12:05'!
cascaded2
	"Answer the value of cascaded2"

	^ cascaded2! !

!MJMockObject methodsFor: 'accessing' stamp: 'jmck 7/2/2011 12:05'!
cascaded2: anObject
	"Set the value of cascaded2"

	cascaded2 := anObject! !

!MJMockObject methodsFor: 'accessing' stamp: 'JohnMcKeon 10/4/2010 20:46'!
date
	"Answer the value of date"

	^ date! !

!MJMockObject methodsFor: 'accessing' stamp: 'JohnMcKeon 10/4/2010 20:46'!
date: anObject
	"Set the value of date"

	date := anObject! !

!MJMockObject methodsFor: 'accessing' stamp: 'jmck 3/8/2011 20:03'!
replace1
	"Answer the value of replace1"

	^ replace1! !

!MJMockObject methodsFor: 'accessing' stamp: 'jmck 3/8/2011 20:03'!
replace1: anObject
	"Set the value of replace1"

	replace1 := anObject! !

!MJMockObject methodsFor: 'accessing' stamp: 'jmck 3/8/2011 20:03'!
replace2
	"Answer the value of replace2"

	^ replace2! !

!MJMockObject methodsFor: 'accessing' stamp: 'jmck 3/8/2011 20:03'!
replace2: anObject
	"Set the value of replace2"

	replace2 := anObject! !

!MJMockObject methodsFor: 'accessing' stamp: 'jmck 1/28/2011 20:31'!
searchobject
	"Answer the value of searchobject"

	^ searchobject! !

!MJMockObject methodsFor: 'accessing' stamp: 'jmck 1/28/2011 20:31'!
searchobject: anObject
	"Set the value of searchobject"

	searchobject := anObject! !

!MJMockObject methodsFor: 'accessing' stamp: 'JohnMcKeon 10/4/2010 20:46'!
time
	"Answer the value of time"

	^ time! !

!MJMockObject methodsFor: 'accessing' stamp: 'JohnMcKeon 10/4/2010 20:46'!
time: anObject
	"Set the value of time"

	time := anObject! !

Object subclass: #MJSearchObject
	instanceVariableNames: 'testValue lookupValue replace1 replace2 cascade1 cascade2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-JQueryWidgetBox-Tests'!

!MJSearchObject commentStamp: 'jmck 7/2/2011 12:19' prior: 0!
A MJSearchObject is the looked-up object in the magritte form. When one is selected, it's various relators will perform their magic by updating the memento. The script of the lookup component will then update the various components represented by the relators. Cascaded relators will now show the selections available in my cascade1 and cascade2 collections. Replaced relators will have their components rerendered showing the new value in the memento. The update relator, if it exists will display whatever is returned by my instance side description named 'description', UpdateId. (For an updateId of #info, there must be a description named descriptionInfo).

!

!MJSearchObject methodsFor: 'accessing' stamp: 'jmck 7/2/2011 13:17'!
cascade1
	"Answer the value of cascade1"

	^ cascade1! !

!MJSearchObject methodsFor: 'accessing' stamp: 'jmck 7/2/2011 13:17'!
cascade1: anObject
	"Set the value of cascade1"

	cascade1 := anObject! !

!MJSearchObject methodsFor: 'accessing' stamp: 'jmck 7/2/2011 13:17'!
cascade2
	"Answer the value of cascade2"

	^ cascade2! !

!MJSearchObject methodsFor: 'accessing' stamp: 'jmck 7/2/2011 13:17'!
cascade2: anObject
	"Set the value of cascade2"

	cascade2 := anObject! !

!MJSearchObject methodsFor: 'accessing' stamp: 'jmck 1/29/2011 11:22'!
descriptionLookup
	| result |
	result := MAContainer new
		add: self descriptionLookupValue;
		componentRenderer: MACssRenderer;
		yourself.
	^result
		! !

!MJSearchObject methodsFor: 'accessing' stamp: 'jmck 1/29/2011 11:22'!
descriptionLookupValue
	^MAStringDescription new
		accessor: #lookupValue;
		label: '';
		beReadonly;
		priority: 10;
		yourself! !

!MJSearchObject methodsFor: 'accessing' stamp: 'jmck 7/2/2011 12:45'!
initialize
	| size |
	super initialize.
	size := 10 atRandom. 
	cascade1 := (1 to: size)
		inject: OrderedCollection new
		into: [ :c :i | c add: (MJCascadedObject new testValue: 100 atRandom; yourself). c ].
	size := 10 atRandom. 
	cascade2 :=  (1 to: size)
		inject: OrderedCollection new
		into: [ :c :i | c add: (MJCascadedObject new testValue: 100 atRandom; yourself). c ].
! !

!MJSearchObject methodsFor: 'accessing' stamp: 'jmck 1/29/2011 10:41'!
lookupValue
	"Answer the value of lookupValue"

	^ lookupValue! !

!MJSearchObject methodsFor: 'accessing' stamp: 'jmck 1/29/2011 10:41'!
lookupValue: anObject
	"Set the value of lookupValue"

	lookupValue := anObject! !

!MJSearchObject methodsFor: 'accessing' stamp: 'jmck 1/28/2011 19:55'!
printOn: aStream
	aStream nextPutAll: testValue! !

!MJSearchObject methodsFor: 'accessing' stamp: 'jmck 3/8/2011 20:00'!
replace1
	"Answer the value of replace1"

	^ replace1! !

!MJSearchObject methodsFor: 'accessing' stamp: 'jmck 3/8/2011 20:00'!
replace1: anObject
	"Set the value of replace1"

	replace1 := anObject! !

!MJSearchObject methodsFor: 'accessing' stamp: 'jmck 3/8/2011 20:00'!
replace2
	"Answer the value of replace2"

	^ replace2! !

!MJSearchObject methodsFor: 'accessing' stamp: 'jmck 3/8/2011 20:00'!
replace2: anObject
	"Set the value of replace2"

	replace2 := anObject! !

!MJSearchObject methodsFor: 'accessing' stamp: 'jmck 1/28/2011 19:50'!
testValue
	"Answer the value of testValue"

	^ testValue! !

!MJSearchObject methodsFor: 'accessing' stamp: 'jmck 1/28/2011 19:50'!
testValue: anObject
	"Set the value of testValue"

	testValue := anObject! !

!MAToOneRelationDescription methodsFor: '*magritte-jquerywidgetbox' stamp: 'jmck 2/19/2011 00:51'!
listFields
	"Array of selectors to be sent to instances to match against entered search text"
	^self propertyAt: #listFields ifAbsent: [ Array with: self classes first instVarNames first ]! !

!MAToOneRelationDescription methodsFor: '*magritte-jquerywidgetbox' stamp: 'jmck 2/19/2011 00:51'!
listFields: anArray
	"Array of selectors to be sent to instances to match against search text entered into autocomplete component"
	^self propertyAt: #listFields put: anArray! !

!MAToOneRelationDescription methodsFor: '*magritte-jquerywidgetbox' stamp: 'jmck 4/10/2011 00:41'!
searchFields
	"Array of selectors to be sent to instances to match against entered search text"
	^self propertyAt: #searchFields ifAbsent: [ Array with: self classes first instVarNames first asSymbol ]! !

!MAToOneRelationDescription methodsFor: '*magritte-jquerywidgetbox' stamp: 'jmck 1/25/2011 20:42'!
searchFields: anArray
	"Array of selectors to be sent to instances to match against search text entered into autocomplete component"
	^self propertyAt: #searchFields put: anArray! !

!MAToOneRelationDescription methodsFor: '*magritte-jquerywidgetbox' stamp: 'jmck 1/29/2011 12:44'!
updateId
	"Return an optional id to be updated onClose. Model object MUST implement an instance method that returns a description to be rendered in the update script"
	^self propertyAt: #updateId ifAbsent: [ nil ]! !

!MAToOneRelationDescription methodsFor: '*magritte-jquerywidgetbox' stamp: 'jmck 1/29/2011 12:46'!
updateId: aSymbol
	"Provide an optional id to be updated onClose. Model object MUST implement an instance method that returns a description (#descriptionASymbol) to be rendered in the update script."
	self propertyAt: #updateId put: aSymbol! !

!MADescriptionComponent methodsFor: '*magritte-jquerywidgetbox' stamp: 'jmck 3/29/2011 21:43'!
cascadeId
	^self description cascadeId! !

!MADescriptionComponent methodsFor: '*magritte-jquerywidgetbox' stamp: 'jmck 2/8/2011 20:25'!
isUndefined
	^false! !

!MADescriptionComponent methodsFor: '*magritte-jquerywidgetbox' stamp: 'jmck 3/29/2011 21:42'!
replaceId
	^self description replaceId! !

MAExternalEditorComponent subclass: #MJExternalEditorComponent
	instanceVariableNames: 'replaceIds selectionIds cascadeIds'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-JQueryWidgetBox'!

MJExternalEditorComponent subclass: #MJAutocompleteComponent
	instanceVariableNames: 'items listSelector'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-JQueryWidgetBox'!

!MJAutocompleteComponent commentStamp: 'jmck 3/8/2011 21:37' prior: 0!
A MJAutocompleteComponent is a Magritte component for looking up an object on a MAToOneRelationDescription using the jQuery autocompleter.
Send #searchFields: to the description to search instances of model objects for matching text in any of the searchFields.
Send #listFields: to the description to produce the displayed string for the search list
listSelector is sent to the objectClass for custom list generation; defaults to #allInstances
Use #updateId: to have a script included which updates a div using the description returned by sending to the model object #descriptionASymbol, where 'aSymbol' is the supplied id. Kind of crazy I know...

replaceIds are used as follows: The description is searched for those descriptions which have a given replaceId in their properties. Given replaceIds = #(#a #b), there should be two OTHER descriptions, one each with  replaceId of #a or #b in their properties. When an object is selected from the list, it will be sent (perform:) the replaceIds for its corresponding values and those values will populate the described object written to it using its respective description. This is handy for populating defaults from a looked-up object. Say an item is looked up for an order, you would want the order line item updated with the looked-up item's price and cost say....



See functional test for an example.


Instance Variables
	items:		a 'temp' variable that stores the collection of found items for a search term. It is a cache to speed up the search for the selected item in #modelFor:
!

!MJAutocompleteComponent class methodsFor: 'as yet unclassified' stamp: 'jmck 1/24/2011 21:00'!
isAbstract
	^false! !

!MJAutocompleteComponent methodsFor: 'accessing-dynamic' stamp: 'jmck 3/8/2011 20:49'!
displayStringFor: aModel
	^aModel notNil
		ifTrue: [ String streamContents: [ :strm |
			self listFields
				do: [ :fld | | v | (v := aModel perform: fld) isNil ifFalse: [ strm nextPutAll: v asString ] ]
				separatedBy: [ strm nextPut: $ ] ] ]
		ifFalse: [ '' ]! !

!MJAutocompleteComponent methodsFor: 'initialization' stamp: 'jmck 1/29/2011 14:45'!
initialize
	super initialize.
	items := OrderedCollection new! !

!MJAutocompleteComponent methodsFor: 'accessing-dynamic' stamp: 'jmck 3/8/2011 21:39'!
listFields
	^description listFields ifNil: [ self searchFields ]! !

!MJAutocompleteComponent methodsFor: 'accessing' stamp: 'jmck 7/2/2011 13:15'!
listSelector
	"this will be sent to the lookup class to get the list to which the search  will apply"
	^listSelector ifNil: [ #allInstances ]! !

!MJAutocompleteComponent methodsFor: 'accessing' stamp: 'jmck 3/8/2011 21:06'!
listSelector: aSymbol
	"this will be sent to the lookup class to get the list to which the search  will apply"
	listSelector := aSymbol! !

!MJAutocompleteComponent methodsFor: 'lookup' stamp: 'jmck 2/19/2011 00:56'!
modelFor: aTerm
	items isEmptyOrNil ifTrue: [ ^self value ].
	^items detect: [ :each | 
			(self displayStringFor: each) = aTerm ] ifNone: [ nil ] 
		! !

!MJAutocompleteComponent methodsFor: 'rendering' stamp: 'jmck 7/2/2011 15:34'!
renderEditorOn: html
	| id |
	id := self updateId.
	html textInput
			id: html lastId;
			attributeAt: 'autocomplete' put: 'off';
			class: 'ui-widget-content';
			value: (self displayStringFor: self value);
			callback: [ :text | self value: (self modelFor: text) ];
			script: (html jQuery this autocomplete
				sourceCallback: [ :term | self searchResult: term ];
				onClose: (html jQuery ajax
					serializeThis; 
					script: [ :s |
							self 
								updateId: id on: s;
								replaceIdsOn: s;
								cascadeIdsOn: s ])).
	self renderButtonsOn: html.
	id isNil
		ifFalse: [
			html div
				id: id;
				with: [ self value isNil ifFalse: [ html render: (self lookUp: id) ] ] ]
! !

!MJAutocompleteComponent methodsFor: 'accessing-dynamic' stamp: 'jmck 1/24/2011 21:17'!
searchClass
	^description classes first! !

!MJAutocompleteComponent methodsFor: 'accessing-dynamic' stamp: 'jmck 1/24/2011 20:41'!
searchFields
	"Answer the value of searchFields"

	^ description searchFields! !

!MJAutocompleteComponent methodsFor: 'accessing-dynamic' stamp: 'jmck 3/8/2011 21:22'!
searchResult: searchTerm
	(searchTerm isNil or:[ searchTerm = '']) ifTrue: [ ^ #() ].
	items := (self searchClass perform: self listSelector)
		select: [ :each | 
			self searchFields anySatisfy: [ :fld | | value |
					value := each perform: fld.
					value notNil and: [ value asString asLowercase beginsWith: searchTerm asLowercase ] ] ].
	^items collect: [ :each | self displayStringFor: each ]
		
! !

!MJAutocompleteComponent methodsFor: 'accessing-model' stamp: 'jmck 6/26/2011 21:13'!
value: anObject
	super value: anObject.
	anObject ifNil: [ ^self ].
	self cascadeIds do: [ :component |
		component isUndefined
			ifFalse: [ component cascade: anObject ]].
	self replaceIds do: [ :component |
		component isUndefined
			ifFalse: [ component value: (anObject perform: component replaceId) ]]! !

!MJExternalEditorComponent methodsFor: 'lookup' stamp: 'jmck 7/2/2011 15:23'!
cascadeIds
	^cascadeIds
		ifNil: [ cascadeIds := (self description cascadeIds
			inject: OrderedCollection new
			into: [ :rslt :id | 
				rslt add: (self parent children
					detect: [ :each | each cascadeId = id ]
					ifNone: [ MAUndefinedComponent new ]).
				rslt ]) ]! !

!MJExternalEditorComponent methodsFor: 'rendering' stamp: 'jmck 7/2/2011 15:10'!
cascadeIdsOn: aScript
	self cascadeIds do: [ :component |
		component isUndefined
			ifFalse: [ aScript << ((aScript jQuery id: (component ajaxId: 'label'))
				replaceWith: component) ] ]! !

!MJExternalEditorComponent methodsFor: 'actions' stamp: 'jmck 7/1/2011 22:27'!
edit
	self chooser: (self editorFor: (self value ifNil: [ self selected new ]))! !

!MJExternalEditorComponent methodsFor: 'lookup' stamp: 'jmck 7/1/2011 22:26'!
lookUp: aDivId
	| desc selector |
	selector := ('description', aDivId capitalized) asSymbol.
	desc :=  [ self value perform: selector ]
		on: Error
		do: [ ^MAUndefinedComponent new ].
	^desc asComponentOn: self value! !

!MJExternalEditorComponent methodsFor: 'rendering' stamp: 'jmck 7/1/2011 22:29'!
renderButtonsOn: html
	"html submitButton on: #create of: self."
	html submitButton on: #edit of: self! !

!MJExternalEditorComponent methodsFor: 'lookup' stamp: 'jmck 7/2/2011 15:22'!
replaceIds
	^replaceIds
		ifNil: [ replaceIds := (self description replaceIds
			inject: OrderedCollection new
			into: [ :rslt :id | 
				rslt add: (self parent children 
					detect: [ :each | each replaceId = id ]
					ifNone: [ MAUndefinedComponent new ]).
				rslt ]) ]! !

!MJExternalEditorComponent methodsFor: 'rendering' stamp: 'jmck 7/1/2011 22:24'!
replaceIdsOn: aScript
	self replaceIds do: [ :component |
		component isUndefined
			ifFalse: [ aScript << ((aScript jQuery id: (component ajaxId: 'label'))
				replaceWith: component) ] ]! !

!MJExternalEditorComponent methodsFor: 'rendering' stamp: 'jmck 7/2/2011 13:44'!
scriptOnCloseOn: html withId: anId
	html jQuery ajax
			serializeThis; 
			script: [ :s |
					self 
						updateId: anId on: s;
						replaceIdsOn: s;
						cascadeIdsOn: s ]! !

!MJExternalEditorComponent methodsFor: 'lookup' stamp: 'jmck 7/2/2011 15:23'!
updateId
	^self description updateId! !

!MJExternalEditorComponent methodsFor: 'rendering' stamp: 'jmck 7/1/2011 22:25'!
updateId: anId on: aScript
	anId isNil
		ifFalse: [ aScript << (aScript jQuery: anId) load
			html: (self lookUp: anId) ]! !

MJExternalEditorComponent subclass: #MJSelectComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-JQueryWidgetBox'!

!MJSelectComponent commentStamp: '<historical>' prior: 0!
An embeddedobject lookup component
Good for one-to-one object lookup, renders the create button to add a new lookup object to the lookup list.!

MJSelectComponent subclass: #MJCascadeSelectComponent
	instanceVariableNames: 'cascade'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-JQueryWidgetBox'!

!MJCascadeSelectComponent methodsFor: 'as yet unclassified' stamp: 'jmck 7/1/2011 22:05'!
cascade
	| id desc |
	(id := self description cascadeId) isNil
		ifFalse: [ desc := self parent description detect: [ :each | each cascadeIds includes: id ].
			^self memento readUsing: desc ].
	^nil! !

!MJCascadeSelectComponent methodsFor: 'as yet unclassified' stamp: 'jmck 7/1/2011 22:05'!
cascade: anObject
	cascade := anObject! !

!MJCascadeSelectComponent methodsFor: 'as yet unclassified' stamp: 'jmck 7/1/2011 22:05'!
instances
	| result c |
	(c := self cascade) ifNil: [ ^nil ].
	result := c perform: self cascadeId.
	^result! !

!MJCascadeSelectComponent methodsFor: 'as yet unclassified' stamp: 'jmck 7/1/2011 22:05'!
renderViewerOn: html
	html label: [ 'Select a ', self cascadeId capitalized ]! !

!MJCascadeSelectComponent methodsFor: 'actions' stamp: 'jmck 7/1/2011 22:05'!
value: anObject
	| objects |
	objects := cascade perform: self cascadeId.
	(objects includes: anObject)
		ifFalse: [ objects add: anObject.
			 cascade save ].
	super value: anObject! !

!MJSelectComponent methodsFor: 'rendering' stamp: 'jmck 7/2/2011 13:39'!
instances
	^self selected allInstances! !

!MJSelectComponent methodsFor: 'rendering' stamp: 'jmck 7/1/2011 22:11'!
renderEditorOn: html
	| id |
	id := self updateId.
	html div
		id: self labelId; 
		with: [ self renderSelectListOn: html withId: id.
			self description isEditable
				ifTrue: [ super renderSelectButtonOn: html ]].
	id isNil
		ifFalse: [
			html div
				id: id;
				with: [ self value isNil ifFalse: [ html render: (self lookUp: id) ] ] ]
! !

!MJSelectComponent methodsFor: 'rendering' stamp: 'jmck 7/1/2011 22:04'!
renderSelectListOn: html
	| instances | 
	((instances := self instances) isNil or: [ instances isEmpty ])
			ifFalse: [
				html select
					id: self labelId;
					list: ((Array with: nil) , instances);
					selected: self value;
					callback: self selectCallback ]
			ifTrue: [ self renderViewerOn: html ] "[ html text: ('No ' , (self selected asString allButFirst: 2) , 's found') ]"
! !

!MJSelectComponent methodsFor: 'rendering' stamp: 'jmck 7/2/2011 16:15'!
renderSelectListOn: html withId: anId
	| instances | 
	((instances := self instances) isNil or: [ instances isEmpty ])
			ifFalse: [
				html select
					id: self labelId;
					list: ((Array with: nil) , instances);
					selected: self value;
					callback: [ :item | self value: item ];
					script: (html jQuery this
						onChange: (html jQuery ajax
							serializeThisWithHidden;
							script: [ :s |
								self 
									updateId: anId on: s;
									replaceIdsOn: s;
									cascadeIdsOn: s ]))]
			ifTrue: [ self renderViewerOn: html ] "[ html text: ('No ' , (self selected asString allButFirst: 2) , 's found') ]"
! !

!MJSelectComponent methodsFor: 'rendering' stamp: 'jmck 7/1/2011 22:04'!
selectCallback
	^[ :item | item ifNotNil: [ self value: item ] ]! !
MJFunctionalTest initialize!
